---
title: ParentNode.prepend()
slug: Web/API/ParentNode/prepend
tags:
  - API
  - DOM
  - Method
  - Node
  - ParentNode
  - Reference
  - prepend
---
<p>{{APIRef("DOM")}}</p>

<p>The <strong><code>ParentNode.prepend()</code></strong> method inserts a set of {{domxref("Node")}} objects or {{domxref("DOMString")}} objects before the first child of the {{domxref("ParentNode")}}. {{domxref("DOMString")}} objects are inserted as equivalent {{domxref("Text")}} nodes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>ParentNode</em>.prepend(<em>...nodesOrDOMStrings</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>nodesOrDOMStrings</code></dt>
 <dd>A set of {{domxref("Node")}} or {{domxref("DOMString")}} objects to insert.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>{{domxref("HierarchyRequestError")}}: Node cannot be inserted at the specified point in the hierarchy.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Prepending_an_element">Prepending an element</h3>

<pre class="brush: js notranslate">var parent = document.createElement("div");
var p = document.createElement("p");
var span = document.createElement("span");
parent.append(p);
parent.prepend(span);

console.log(parent.childNodes); // NodeList [ &lt;span&gt;, &lt;p&gt; ]
</pre>

<h3 id="Prepending_text">Prepending text</h3>

<pre class="brush: js notranslate">var parent = document.createElement("div");
parent.append("Some text");
parent.prepend("Headline: ");

console.log(parent.textContent); // "Headline: Some text"</pre>

<h3 id="Appending_an_element_and_text">Appending an element and text</h3>

<pre class="brush: js notranslate">var parent = document.createElement("div");
var p = document.createElement("p");
parent.prepend("Some text", p);

console.log(parent.childNodes); // NodeList [ #text "Some text", &lt;p&gt; ]</pre>

<h3 id="ParentNode.prepend_is_unscopable">ParentNode.prepend() is unscopable</h3>

<p>The <code>prepend()</code> method is not scoped into the <code>with</code> statement. See {{jsxref("Symbol.unscopables")}} for more information.</p>

<pre class="brush: js notranslate">var parent = document.createElement("div");

with(parent) {
  prepend("foo");
}
// ReferenceError: prepend is not defined </pre>

<h2 id="Polyfill">Polyfill</h2>

<p>You can polyfill the <code>prepend()</code> method if it's not available:</p>

<pre class="brush: js notranslate">// Source: https://github.com/jserz/js_piece/blob/master/DOM/ParentNode/prepend()/prepend().md
(function (arr) {
  arr.forEach(function (item) {
    if (item.hasOwnProperty('prepend')) {
      return;
    }
    Object.defineProperty(item, 'prepend', {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function prepend() {
        var argArr = Array.prototype.slice.call(arguments),
          docFrag = document.createDocumentFragment();

        argArr.forEach(function (argItem) {
          var isNode = argItem instanceof Node;
          docFrag.appendChild(isNode ? argItem : document.createTextNode(String(argItem)));
        });

        this.insertBefore(docFrag, this.firstChild);
      }
    });
  });
})([Element.prototype, Document.prototype, DocumentFragment.prototype]);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-parentnode-prepend', 'ParentNode.prepend()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ParentNode.prepend")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("ParentNode")}} and {{domxref("ChildNode")}}</li>
 <li>{{domxref("ParentNode.append()")}}</li>
 <li>{{domxref("Node.appendChild()")}}</li>
 <li>{{domxref("Node.insertBefore()")}}</li>
 <li>{{domxref("ChildNode.before()")}}</li>
 <li>{{domxref("Element.insertAdjacentElement()")}}</li>
 <li>{{domxref("NodeList")}}</li>
</ul>
